/* -*-C-*-

Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
    2016, 2017, 2018, 2019 Matthew Birkholz

This file is part of a Gtk plugin for MIT/GNU Scheme Pucked.

This plugin is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This plugin is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this plugin; if not, write to the Free Software Foundation,
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

*/

/* A specialized GtkPaned.  See documentation of <gtk-paned-view>. */

/* The v3.20.9 of GtkPaned seems to do the right thing with
   GtkScrolledViews, so this version of GtkPanedView is not actually
   specialized. */

#include "gtkpanedview.h"

G_DEFINE_TYPE (GtkPanedView, gtk_paned_view,
	       GTK_TYPE_PANED)

static void
gtk_paned_view_class_init (GtkPanedViewClass *class)
{
}

static void
gtk_paned_view_init (GtkPanedView *paned_view)
{
}

/**
 * gtk_paned_view_new:
 * @orientation: GTK_ORIENTATION_VERTICAL or GTK_ORIENTATION_HORIZONTAL.
 *
 * Creates a new paned view.
 *
 * Returns: a new paned view.
 */
GtkWidget*
gtk_paned_view_new (GtkOrientation orientation)
{
  return (g_object_new (GTK_TYPE_PANED_VIEW,
			"orientation", orientation,
			NULL));
}
