/* -*-C-*-

Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
    2016, 2017, 2018, 2019 Matthew Birkholz

This file is part of a Gtk plugin for MIT/GNU Scheme Pucked.

This plugin is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This plugin is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this plugin; if not, write to the Free Software Foundation,
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

*/

/* A specialized GtkPaned.  See documentation of <gtk-paned-view>. */

#include <gtk/gtk.h>

#define GTK_TYPE_PANED_VIEW            (gtk_paned_view_get_type ())
#define GTK_PANED_VIEW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_PANED_VIEW, GtkPanedView))
#define GTK_PANED_VIEW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), GTK_TYPE_PANED_VIEW, GtkPanedViewClass))
#define GTK_IS_PANED_VIEW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_PANED_VIEW))
#define GTK_IS_PANED_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_TYPE_PANED_VIEW))
#define GTK_PANED_VIEW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_PANED_VIEW, GtkPanedViewClass))


typedef struct _GtkPanedView		GtkPanedView;
typedef struct _GtkPanedViewClass	GtkPanedViewClass;

struct _GtkPanedView
{
  GtkPaned paned;
};

struct _GtkPanedViewClass
{
  GtkPanedClass parent_class;
};


GType          gtk_paned_view_get_type (void) G_GNUC_CONST;
GtkWidget*     gtk_paned_view_new      (GtkOrientation orientation);
