#| -*-Scheme-*-

Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
    2016, 2017, 2018, 2019 Matthew Birkholz

This file is part of a Gtk plugin for MIT/GNU Scheme Pucked.

This plugin is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This plugin is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this plugin; if not, write to the Free Software Foundation,
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

|#

;;;; Gtk Keys
;;; Package: (gtk keys)

(define (gdk-key-state->char-bits modifier-state)
  (fix:+
   (if (bit? modifier-state (C-enum "GDK_CONTROL_MASK")) char-bit:control 0)
   (fix:+
    (if (bit? modifier-state (C-enum "GDK_META_MASK")) char-bit:meta 0)
    (fix:+
     (if (bit? modifier-state (C-enum "GDK_MOD1_MASK")) char-bit:meta 0)
     (fix:+
      (if (bit? modifier-state (C-enum "GDK_SUPER_MASK")) char-bit:super 0)
      (if (bit? modifier-state (C-enum "GDK_HYPER_MASK")) char-bit:hyper 0))))))

(define (gdk-keyval->name keyval)
  (let ((entry
	 (vector-binary-search gtk-key-translation-table
			       (lambda (u v) (< u v))
			       (lambda (pair) (car pair))
			       keyval)))
    (and entry (cdr entry))))

(define-syntax translation-vector
  (sc-macro-transformer
   (lambda (form usage-env)
       (list->vector
	(map (lambda (gdk-name.keyval)
	       (let* ((keyval (cdr gdk-name.keyval))
		      (gdk-name (car gdk-name.keyval))
		      (string (symbol->string gdk-name))
		      (name (cond ((string-prefix? "GDK_KEY_" string)
				   (string->symbol (string-tail string 8)))
				  (else
				   (warn "Unexpected GdkKeysym name:" gdk-name)
				   gdk-name))))
		 (cons keyval name)))
	     (c-enum-constant-values '(ENUM |GdkKeysyms|) form
				     (find-c-includes usage-env)))))))

(define gtk-key-translation-table
  (sort! (translation-vector) (lambda (a b) (< (car a) (car b)))))