/* -*-C-*-

Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
    2016, 2017, 2018, 2019 Matthew Birkholz

This file is part of a Gtk plugin for MIT/GNU Scheme Pucked.

This plugin is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This plugin is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this plugin; if not, write to the Free Software Foundation,
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

*/

/* Header for scmwidget.c. */

#define GTK_TYPE_SCMWIDGET (scm_widget_get_type ())
#define SCM_WIDGET(obj)    (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_SCMWIDGET, ScmWidget))
#define SCM_IS_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_SCMWIDGET))

typedef struct _ScmWidgetClass ScmWidgetClass;
typedef struct _ScmWidget ScmWidget;

struct _ScmWidgetClass
{
  GtkWidgetClass parent_class;
};

struct _ScmWidget
{
  GtkWidget widget;
  gint minimum_width;
  gint minimum_height;
  gint natural_width;
  gint natural_height;
  GtkAdjustment *hadjustment;
  GtkAdjustment *vadjustment;
  guint hscroll_policy;
  guint vscroll_policy;
};

extern GtkWidget* scm_widget_new (void);
